Attribute VB_Name = "mCD"
Option Explicit

Public Type HMSF
   h As Byte
   m As Byte
   s As Byte
   f As Byte
End Type

Public Type ADAPTER_INFO
   MaximumTransferLength As Long
   MaximumPhysicalPages  As Long
   AlignmentMask         As Long
   AdapterUsesPio        As Boolean
   AdapterScansDown      As Boolean
   CommandQueueing       As Boolean
   AcceleratedTransfer   As Boolean
   BusType               As String
   BusMajorVersion       As Integer
   BusMinorVersion       As Integer
End Type

Public Type INDIVIDUAL_CAPABILITIES
'**************** Byte 2 (Read) *****************
    CD_R_Read           As Boolean 'Bit 0
    CD_RW_Read          As Boolean 'Bit 1
    Method2_Read        As Boolean 'Bit 2
    DVD_ROM_Read        As Boolean 'Bit 3
    DVD_R_Read          As Boolean 'Bit 4
    DVD_RAM_Read        As Boolean 'Bit 5
'Bits 6-7 - reserved
'**************** Byte 3 (Write) *****************
    CD_R_Write          As Boolean 'Bit 0
    CD_RW_Write         As Boolean 'Bit 1
    Test_Write          As Boolean 'Bit 2
'Bit 3 - reserved
    DVD_R_Write         As Boolean 'Bit 4
    DVD_RAM_Write       As Boolean 'Bit 5
'Bits 6-7 - reserved
'**************** Byte 4 (Play) *****************
    AudioPlay           As Boolean 'Bit 0
    Composite           As Boolean 'Bit 1
    DigitalPort1        As Boolean 'Bit 2
    DigitalPort2        As Boolean 'Bit 3
    Mode2Form1          As Boolean 'Bit 4
    Mode2Form2          As Boolean 'Bit 5
    MultiSession        As Boolean 'Bit 6
    BUF_Under_Run_Free  As Boolean 'Bit 7
'**************** Byte 5 (Play more) **********
    CDDA                As Boolean 'Bit 0
    CDDA_Accurate       As Boolean 'Bit 1
    R_W_Supported       As Boolean 'Bit 2
    R_W_Deinterleaved   As Boolean 'Bit 3
    C2_Pointers         As Boolean 'Bit 4
    ISRC                As Boolean 'Bit 5
    UPC                 As Boolean 'Bit 6
    Read_Bar_Code       As Boolean 'Bit 7
'**************** Byte 6 (Load/Unload)*********
    Lock                As Boolean 'Bit 0
    LockState           As Boolean 'Bit 1
    PreventJumper       As Boolean 'Bit 2
    Eject               As Boolean 'Bit 3
'Bit 4 - reserved
    LoadingMechType     As Byte    'Bits 5-7
'**************** Byte 7 (Changer)*************
    SeparateVolumeLevel As Boolean 'Bit 0
    SeparateChannelMute As Boolean 'Bit 1
    SupportDiskPresent  As Boolean 'Bit 2
    SW_SlotSelection    As Boolean 'Bit 3
    SideChangeCapable   As Boolean 'Bit 4
    RW_In_LeadIn        As Boolean 'Bit 5
'Bits 6-7 - reserved
End Type

Public Type DIGITAL_OUTPUT_FORMAT 'Byte 17
    BCKF        As Boolean 'Bit 1
    RCK         As Boolean 'Bit 2
    LSBF        As Boolean 'Bit 3
    WordLength  As String  'Bit 4-5
End Type

Public Type DEVICE_INFO
   BufferSize               As Long
   BusType                  As String
   Capabilities             As INDIVIDUAL_CAPABILITIES
   CopyManagement           As Long
   CurReadSpeed             As Long   'in kB/sec.
   CurWriteSpeed            As Long   'in kB/sec.
   DeviceType               As Long
'   DeviceID                 As Long
   DeviceAddress            As SCSI_ADDRESS
   DOF                      As DIGITAL_OUTPUT_FORMAT
'   DriveLetter              As String
'   FriendlyName             As String
   MaxReadSpeed             As Long   'in kB/sec.
   MaxWriteSpeed            As Long   'in kB/sec.
'   NTPath                   As String
   ProductID                As String
   ProductRev               As String
   RotationControlSelected  As Byte
   SerialNumber             As String
   VendorName               As String
   VolumeLevels             As Long
   numWPD                   As Long
   WPD()                    As WRITE_PERFORMANCE_DESCRIPTOR
End Type

Public Type MEDIA_INFO
   MediaType As String
   DataType As Long
   Present As Boolean
   Characteristics As Long
   Cylinders As Currency
   TracksPerCylinder As Long
   SectorsPerTrack As Long
   BytesPerSector As Long
   MediaSides As Long
   VolumeLabel As String
   VolumeSerial As String
   FileSystem As String
   Formatted As Boolean
   Capacity As Double
   BytesTotal As Double
   BytesFree As Double
   BytesAvailable As Double
   BytesInUse As Double
   DiskStatus As String
   LastSessionStatus As String
   Eraseable As Boolean
   FirstTrackNumber As Byte
   NumberOfSessions As Long
   LastSessionFirstTrack As Long
   LastSessionLastTrack As Long
   DiskType As String
   DiskIdentification As HMSF
   LastSessionLeadIn  As HMSF
   LastPossibleLeadOut As HMSF
End Type

Public Type CD_INFO
   ai As ADAPTER_INFO
   di As DEVICE_INFO
   mi As MEDIA_INFO
End Type

Public Type CD_SHORT_INFO
   DriveLetter As String
   FriendlyName As String
   DeviceID As Long
   DeviceType As Long
End Type

Public cdi_short() As CD_SHORT_INFO
Public cdi As CD_INFO

Public Function EnumCDDrives() As Long
   Dim sDrive As String
   Dim i As Long, hDevice As Long, ret As Long, nDevices As Long
   Dim SDN As STORAGE_DEVICE_NUMBER
   Dim sNames() As String
   sNames = GetCDFriendlyNames
   For i = 2 To 26
       sDrive = Chr(Asc("A") + i) & ":"
       If GetDriveType(sDrive) = DRIVE_CDROM Then
          ReDim Preserve cdi_short(nDevices)
          hDevice = CreateFile("\\.\" & sDrive, GENERIC_READ Or GENERIC_WRITE, FILE_SHARE_READ Or FILE_SHARE_WRITE, 0&, OPEN_EXISTING, 0&, 0&)
          If hDevice <> INVALID_HANDLE_VALUE Then
             Call DeviceIoControl(hDevice, IOCTL_STORAGE_GET_DEVICE_NUMBER, _
                  ByVal 0&, 0, SDN, Len(SDN), ret, 0)
             With cdi_short(nDevices)
                 .DeviceID = SDN.DeviceNumber
                 .DriveLetter = Left(sDrive, 1)
'                 .FriendlyName = GetDeviceSetting(DEVICE_CLASS_COMPACT_DISC, .DeviceID, SPDRP_FRIENDLYNAME)
                 .FriendlyName = sNames(.DeviceID)
                 .DeviceType = SDN.DeviceType
             End With
             CloseHandle hDevice
          End If
          nDevices = nDevices + 1
       End If
   Next i
   EnumCDDrives = nDevices
End Function

Public Function GetCDInfo(ByVal sDrive As String) As Boolean
   Dim s As String
   Dim i As Long, hDevice As Long, ret As Long, j As Long
   Dim cpLength As Long, nWPD As Long
   Dim sa As SCSI_ADDRESS
   Dim sptwb As SCSI_PASS_THROUGH_WITH_BUFFERS
   Dim gmt As GET_MEDIA_TYPES
   Dim sdd As STORAGE_DEVICE_DESCRIPTOR
   Dim sad As STORAGE_ADAPTER_DESCRIPTOR
   Dim spq As STORAGE_PROPERTY_QUERY
   Dim CP As CAPABILITY_PAGE
   Dim SDN As STORAGE_DEVICE_NUMBER
   Dim cdt As CDROM_DATA_TYPE
   Dim toc As CDROM_TOC
   Dim dblTotal As Double
   
   Dim abBuffer() As Byte
   Dim cdi_new As CD_INFO
   
   sDrive = Left(sDrive, 1) & ":"
   hDevice = CreateFile("\\.\" & sDrive, GENERIC_READ Or GENERIC_WRITE, FILE_SHARE_READ Or FILE_SHARE_WRITE, 0&, OPEN_EXISTING, 0&, 0&)
   If hDevice = INVALID_HANDLE_VALUE Then Exit Function
   
   ret = SCSI_GET_ADDRESS(hDevice, sa)
   cdi_new.di.DeviceAddress = sa
            
   spq.PropertyId = StorageDeviceProperty
   spq.QueryType = PropertyStandardQuery
   ReDim abBuffer(9999)
   ret = DeviceIoControl(hDevice, IOCTL_STORAGE_QUERY_PROPERTY, _
         spq, Len(spq), abBuffer(0), UBound(abBuffer) + 1, ret, 0)
   If ret = 0 Then GoTo AdapterInfo
   CopyMemory sdd, abBuffer(0), Len(sdd)
   s = Left(StrConv(abBuffer, vbUnicode), sdd.Size)
   With cdi_new.di
      .DeviceType = sdd.DeviceType
      .BusType = TranslateBusType(sdd.BusType)
      .VendorName = Trim(Mid(s, sdd.Version + 9, 8))
      .ProductID = TrimNull(Mid(s, sdd.Version + 17, 16))
      .ProductRev = TrimNull(Mid(s, sdd.Version + 33, 4))
      If sdd.SerialNumberOffset > 0 Then
         .SerialNumber = TrimNull(Mid(s, sdd.SerialNumberOffset + 1))
      End If
   End With
AdapterInfo:
   spq.PropertyId = StorageAdapterProperty
   spq.QueryType = PropertyStandardQuery
   ReDim abBuffer(9999)
   ret = DeviceIoControl(hDevice, IOCTL_STORAGE_QUERY_PROPERTY, _
         spq, Len(spq), abBuffer(0), UBound(abBuffer) + 1, ret, 0)
   If ret = 0 Then GoTo CapabilitiesInfo
   CopyMemory sad, abBuffer(0), Len(sad)
   With cdi_new.ai
      .BusType = TranslateBusType(sad.BusType)
      .AcceleratedTransfer = CBool(sad.AcceleratedTransfer)
      .AdapterScansDown = CBool(sad.AdapterScansDown)
      .AdapterUsesPio = CBool(sad.AdapterUsesPio)
      .CommandQueueing = CBool(sad.CommandQueueing)
      .AlignmentMask = sad.AlignmentMask
      .BusMajorVersion = sad.BusMajorVersion
      .BusMinorVersion = sad.BusMinorVersion
      .MaximumPhysicalPages = sad.MaximumPhysicalPages
      .MaximumTransferLength = sad.MaximumTransferLength
   End With
CapabilitiesInfo:
   ret = SCSI_READ_CAPABILITIES(hDevice, sa, sptwb)
   If ret = 0 Then GoTo MediaInfo
   cpLength = sptwb.DataBuf(1) 'Data length
   CopyMemory CP, sptwb.DataBuf(0), Min(cpLength, 32)
   With cdi_new.di
      .BufferSize = BE_UINT(CP.BufferSize)
      .CopyManagement = BE_UINT(CP.CopyManagement)
      .RotationControlSelected = CP.RotationControlSelected
      .VolumeLevels = BE_UINT(CP.VolumeLevels)
      .MaxReadSpeed = BE_UINT(CP.MaxReadSpeedOld)
      .CurReadSpeed = BE_UINT(CP.CurrentReadSpeadOld)
      .MaxWriteSpeed = BE_UINT(CP.MaxWriteSpeedOld)
      .CurWriteSpeed = BE_UINT(CP.CurrentWriteSpead)
      If .CurWriteSpeed = 0 Then
        .CurWriteSpeed = BE_UINT(CP.CurrentWriteSpeadOld)
      End If
      With .Capabilities
         .CD_R_Read = IsBitSetByte(CP.Capabilities(0), 0)
         .CD_RW_Read = IsBitSetByte(CP.Capabilities(0), 1)
         .Method2_Read = IsBitSetByte(CP.Capabilities(0), 2)
         .DVD_ROM_Read = IsBitSetByte(CP.Capabilities(0), 3)
         .DVD_R_Read = IsBitSetByte(CP.Capabilities(0), 4)
         .DVD_RAM_Read = IsBitSetByte(CP.Capabilities(0), 5)
         .CD_R_Write = IsBitSetByte(CP.Capabilities(1), 0)
         .CD_RW_Write = IsBitSetByte(CP.Capabilities(1), 1)
         .Test_Write = IsBitSetByte(CP.Capabilities(1), 2)
         .DVD_R_Write = IsBitSetByte(CP.Capabilities(1), 4)
         .DVD_RAM_Write = IsBitSetByte(CP.Capabilities(1), 5)
         .AudioPlay = IsBitSetByte(CP.Capabilities(2), 0)
         .Composite = IsBitSetByte(CP.Capabilities(2), 1)
         .DigitalPort1 = IsBitSetByte(CP.Capabilities(2), 2)
         .DigitalPort2 = IsBitSetByte(CP.Capabilities(2), 3)
         .Mode2Form1 = IsBitSetByte(CP.Capabilities(2), 4)
         .Mode2Form2 = IsBitSetByte(CP.Capabilities(2), 5)
         .MultiSession = IsBitSetByte(CP.Capabilities(2), 6)
         .BUF_Under_Run_Free = IsBitSetByte(CP.Capabilities(2), 7)
         .CDDA = IsBitSetByte(CP.Capabilities(3), 0)
         .CDDA_Accurate = IsBitSetByte(CP.Capabilities(3), 1)
         .R_W_Supported = IsBitSetByte(CP.Capabilities(3), 2)
         .R_W_Deinterleaved = IsBitSetByte(CP.Capabilities(3), 3)
         .C2_Pointers = IsBitSetByte(CP.Capabilities(3), 4)
         .ISRC = IsBitSetByte(CP.Capabilities(3), 5)
         .UPC = IsBitSetByte(CP.Capabilities(3), 6)
         .Read_Bar_Code = IsBitSetByte(CP.Capabilities(3), 7)
         .Lock = IsBitSetByte(CP.Capabilities(4), 0)
         .LockState = IsBitSetByte(CP.Capabilities(4), 1)
         .PreventJumper = IsBitSetByte(CP.Capabilities(4), 2)
         .Eject = IsBitSetByte(CP.Capabilities(4), 3)
         .LoadingMechType = RShift(CP.Capabilities(4), 5)
         .SeparateVolumeLevel = IsBitSetByte(CP.Capabilities(5), 0)
         .SeparateChannelMute = IsBitSetByte(CP.Capabilities(5), 1)
         .SupportDiskPresent = IsBitSetByte(CP.Capabilities(5), 2)
         .SW_SlotSelection = IsBitSetByte(CP.Capabilities(5), 3)
         .SideChangeCapable = IsBitSetByte(CP.Capabilities(5), 4)
        .RW_In_LeadIn = IsBitSetByte(CP.Capabilities(5), 5)
      End With
      With .DOF
        .BCKF = IsBitSetByte(CP.DigitalOutputFmt, 1)
        .RCK = IsBitSetByte(CP.DigitalOutputFmt, 2)
        .LSBF = IsBitSetByte(CP.DigitalOutputFmt, 3)
        Select Case RShift(CP.DigitalOutputFmt, 4)
               Case 0: .WordLength = "32"
               Case 1: .WordLength = "16"
               Case 2: .WordLength = "24"
               Case 3: .WordLength = "24(I2S)"
        End Select
     End With
     If cpLength > 32 Then
        nWPD = sptwb.DataBuf(30) * 256 + sptwb.DataBuf(32) 'numWPD
        .numWPD = nWPD
        If nWPD > 0 Then
           ReDim CP.WPD(nWPD - 1)
           ReDim .WPD(nWPD - 1)
           CopyMemory .WPD(0), sptwb.DataBuf(32), nWPD * 4
        End If
     End If
   End With
MediaInfo:
   ret = DeviceIoControl(hDevice, IOCTL_CDROM_DISK_TYPE, _
                         ByVal 0&, 0, cdt, LenB(cdt), ret, ByVal 0&)
   
   ret = DeviceIoControl(hDevice, IOCTL_STORAGE_GET_MEDIA_TYPES_EX, _
                         ByVal 0&, 0, gmt, LenB(gmt), ret, ByVal 0&)
   If gmt.DeviceType <> 0 Then cdi.di.DeviceType = gmt.DeviceType
   
   With cdi_new.mi
      .Present = gmt.MediaInfo(0).MediaCharacteristics And MEDIA_CURRENTLY_MOUNTED
      If .Present Then
         .MediaType = TranslateMediaType(gmt.MediaInfo(0).MediaType)
         .DataType = cdt.lType
         .BytesPerSector = gmt.MediaInfo(0).BytesPerSector
         If .BytesPerSector = 0 Then .BytesPerSector = 2048
         .Cylinders = gmt.MediaInfo(0).Cylinders
         .Characteristics = gmt.MediaInfo(0).MediaCharacteristics
         .MediaSides = gmt.MediaInfo(0).NumberMediaSides
         .SectorsPerTrack = gmt.MediaInfo(0).SectorsPerTrack
         .TracksPerCylinder = gmt.MediaInfo(0).TracksPerCylinder
         .BytesTotal = .Cylinders * 10000 * .TracksPerCylinder * .SectorsPerTrack * .BytesPerSector
         dblTotal = .BytesTotal
         GetVolumeInfo sDrive, .VolumeLabel, .VolumeSerial, .FileSystem
'         If SCSI_READ_FORMAT_CAPACITY(hDevice, sa, sptwb) Then
'            .Formatted = (sptwb.DataBuf(8) = 2)
'            CopyMemory abBuffer(0), sptwb.DataBuf(4), 4
'            .Capacity = BE_ULONG(abBuffer)
'            CopyMemory abBuffer(0), sptwb.DataBuf(9), 4
'            .Capacity = .Capacity * LE_ULONG(abBuffer)
'         End If
'         If .Capacity = 0 Then
         If SCSI_READ_CAPACITY(hDevice, sa, sptwb) Then
            CopyMemory abBuffer(0), sptwb.DataBuf(0), 4
            .Capacity = BE_ULONG(abBuffer)
            CopyMemory abBuffer(0), sptwb.DataBuf(5), 4
            .Capacity = .Capacity * LE_ULONG(abBuffer)
         End If
'         End If
         If SCSI_READ_DISKINFO(hDevice, sa, sptwb) Then
            .DiskStatus = TranslateDiskStatus(sptwb.DataBuf(2) And &H3)
            .LastSessionStatus = TranslateSessionStatus(sptwb.DataBuf(2) \ 4 And &H3)
            .Eraseable = IsBitSetByte(sptwb.DataBuf(2), 4)
            .FirstTrackNumber = sptwb.DataBuf(3)
            .NumberOfSessions = sptwb.DataBuf(9) * 256 + sptwb.DataBuf(4)
            .LastSessionFirstTrack = sptwb.DataBuf(10) * 256 + sptwb.DataBuf(5)
            .LastSessionLastTrack = sptwb.DataBuf(11) * 256 + sptwb.DataBuf(6)
            .DiskType = TranslateDiskType(sptwb.DataBuf(8))
            If IsBitSetByte(sptwb.DataBuf(7), 7) Then
               .DiskIdentification.h = sptwb.DataBuf(12)
               .DiskIdentification.m = sptwb.DataBuf(13)
               .DiskIdentification.s = sptwb.DataBuf(14)
               .DiskIdentification.f = sptwb.DataBuf(15)
            End If
            .LastSessionLeadIn.h = sptwb.DataBuf(16)
            .LastSessionLeadIn.m = sptwb.DataBuf(17)
            .LastSessionLeadIn.s = sptwb.DataBuf(18)
            .LastSessionLeadIn.f = sptwb.DataBuf(19)
            
            .LastPossibleLeadOut.h = sptwb.DataBuf(20)
            .LastPossibleLeadOut.m = sptwb.DataBuf(21)
            .LastPossibleLeadOut.s = sptwb.DataBuf(22)
            .LastPossibleLeadOut.f = sptwb.DataBuf(23)
            
            If (sptwb.DataBuf(23) < 100) And (sptwb.DataBuf(23) > 0) Then
               .BytesTotal = (sptwb.DataBuf(20) * 3600# + sptwb.DataBuf(21) * 60 + sptwb.DataBuf(22)) * 75 + sptwb.DataBuf(23)
               .BytesTotal = .BytesTotal * 2048
               .BytesTotal = Max(.BytesTotal, dblTotal)
            End If
            
            If (sptwb.DataBuf(19) < 100) And (sptwb.DataBuf(19) > 0) Then
               .BytesInUse = (sptwb.DataBuf(16) * 3600# + (sptwb.DataBuf(17)) * 60 + sptwb.DataBuf(18)) * 75 + sptwb.DataBuf(19)
               .BytesInUse = .BytesInUse * 2048
            End If
         End If
         If (.DiskStatus = "Incomplete") And (.LastSessionStatus = "Empty") And (.NumberOfSessions = 1) Then 'Empty disk
            .Formatted = False
            .BytesInUse = 0
            .BytesAvailable = 0
            .Capacity = 0
            .BytesFree = .BytesTotal - .Capacity
         Else
            .Formatted = True
            If .BytesInUse < .Capacity Then .BytesInUse = .Capacity
            If .BytesTotal < .Capacity Then .BytesTotal = .Capacity
            If .BytesInUse > .BytesTotal Then .BytesInUse = .BytesTotal
            .BytesAvailable = .BytesTotal - .BytesInUse
            .BytesAvailable = .BytesAvailable - (60 + 2) * 75# * 2048 'reserved 60 sec for Lead-In and Lead-Out + 2 unused sec
            .BytesFree = .BytesTotal - .Capacity
            If .BytesAvailable < 0 Then .BytesAvailable = 0
         End If
'Get more ifo about tracks
'         ret = DeviceIoControl(hDevice, IOCTL_CDROM_READ_TOC, _
'                         ByVal 0&, 0, toc, LenB(toc), ret, ByVal 0&)
'         For i = 0 To 3
'             Debug.Print toc.TrackData(0).Address(i)
'         Next i
      End If
   End With
   CloseHandle hDevice
   cdi = cdi_new
   GetCDInfo = True
End Function
