Attribute VB_Name = "mDeviceIO"
Option Explicit

Public Enum IO_COMMANDS
   IOCTL_STORAGE_CHECK_VERIFY = &H2D4800
   IOCTL_STORAGE_CHECK_VERIFY2 = &H2D0800
   IOCTL_STORAGE_MEDIA_REMOVAL = &H2D4804
   IOCTL_STORAGE_EJECT_MEDIA = &H2D4808
   IOCTL_STORAGE_LOAD_MEDIA = &H2D480C
   IOCTL_STORAGE_LOAD_MEDIA2 = &H2D080C
   IOCTL_STORAGE_RESERVE = &H2D4810
   IOCTL_STORAGE_RELEASE = &H2D4814
   IOCTL_STORAGE_FIND_NEW_DEVICES = &H2D4818
   IOCTL_STORAGE_EJECTION_CONTROL = &H2D0940
   IOCTL_STORAGE_MCN_CONTROL = &H2D0944
   IOCTL_STORAGE_GET_MEDIA_TYPES = &H2D0C00
   IOCTL_STORAGE_GET_MEDIA_TYPES_EX = &H2D0C04
   IOCTL_STORAGE_GET_MEDIA_SERIAL_NUMBER = &H2D0C10
   IOCTL_STORAGE_GET_HOTPLUG_INFO = &H2D0C14
   IOCTL_STORAGE_SET_HOTPLUG_INFO = &H2DCC18
   IOCTL_STORAGE_RESET_BUS = &H2D5000
   IOCTL_STORAGE_RESET_DEVICE = &H2D5004
   IOCTL_STORAGE_BREAK_RESERVATION = &H2D5014
   IOCTL_STORAGE_GET_DEVICE_NUMBER = &H2D1080
   IOCTL_STORAGE_PREDICT_FAILURE = &H2D1100
   IOCTL_STORAGE_QUERY_PROPERTY = &H2D1400
   IOCTL_SCSI_PASS_THROUGH = &H4D004
   IOCTL_SCSI_MINIPORT = &H4D008
   IOCTL_SCSI_GET_INQUIRY_DATA = &H4100C
   IOCTL_SCSI_GET_CAPABILITIES = &H41010
   IOCTL_SCSI_PASS_THROUGH_DIRECT = &H4D014
   IOCTL_SCSI_GET_ADDRESS = &H41018
   IOCTL_SCSI_RESCAN_BUS = &H4101C
   IOCTL_SCSI_GET_DUMP_POINTERS = &H41020
   IOCTL_SCSI_FREE_DUMP_POINTERS = &H41024
   IOCTL_IDE_PASS_THROUGH = &H4D028
   IOCTL_CDROM_DISK_TYPE = &H20040
   IOCTL_CDROM_READ_TOC = &H24000
End Enum

Public Const MAXIMUM_NUMBER_TRACKS = 100&

Public Type TRACK_DATA
  Reserved As Byte
  Control_adr As Byte
'  UCHAR  Adr : 4;
  TrackNumber As Byte
  Reserved1 As Byte
  Address(3) As Byte
End Type

Public Type CDROM_TOC
   Length As Integer
   FirstTrack As Byte
   LastTrack As Byte
   TrackData(MAXIMUM_NUMBER_TRACKS - 1) As TRACK_DATA
End Type

Public Enum STORAGE_QUERY_TYPE
   PropertyStandardQuery = 0
   PropertyExistsQuery
   PropertyMaskQuery
   PropertyQueryMaxDefined
End Enum
  
Public Enum STORAGE_PROPERTY_ID
   StorageDeviceProperty = 0
   StorageAdapterProperty
   StorageDeviceIdProperty
End Enum

Public Type SCSI_ADDRESS
   Length As Long
   PortNumber As Byte
   PathId As Byte
   TargetId As Byte
   Lun As Byte
End Type

Public Type STORAGE_DEVICE_NUMBER
  DeviceType As Long
  DeviceNumber As Long
  PartitionNumber As Long
End Type

Public Type STORAGE_PROPERTY_QUERY
   PropertyId As STORAGE_PROPERTY_ID
   QueryType As STORAGE_QUERY_TYPE
   AdditionalParameters(511) As Byte
End Type

Public Type STORAGE_ADAPTER_DESCRIPTOR
   Version As Long
   Size As Long
   MaximumTransferLength As Long
   MaximumPhysicalPages As Long
   AlignmentMask As Long
   AdapterUsesPio As Byte
   AdapterScansDown As Byte
   CommandQueueing As Byte
   AcceleratedTransfer As Byte
   BusType As Byte 'STORAGE_BUS_TYPE
   BusMajorVersion As Integer
   BusMinorVersion As Integer
End Type

Public Type STORAGE_DEVICE_DESCRIPTOR
   Version As Long
   Size As Long
   DeviceType As Byte
   DeviceTypeModifier As Byte
   RemovableMedia As Byte
   CommandQueueing As Byte
   VendorIdOffset As Long
   ProductIdOffset As Long
   ProductRevisionOffset As Long
   SerialNumberOffset As Long
   BusType As STORAGE_BUS_TYPE
   RawPropertiesLength As Long
'   RawDeviceProperties() As Byte
End Type

Public Type DEVICE_MEDIA_INFO
   Cylinders As Currency
   MediaType As Long
   TracksPerCylinder As Long
   SectorsPerTrack As Long
   BytesPerSector As Long
   NumberMediaSides As Long
   MediaCharacteristics As Long
End Type

Public Type GET_MEDIA_TYPES
   DeviceType As Long
   MediaInfoCount As Long
   MediaInfo(10) As DEVICE_MEDIA_INFO
End Type
  
Public Enum MEDIA_CHARACTERISTICS
   MEDIA_ERASEABLE = 1
   MEDIA_WRITE_ONCE = 2
   MEDIA_READ_ONLY = 4
   MEDIA_READ_WRITE = 8
   MEDIA_WRITE_PROTECTED = &H100
   MEDIA_CURRENTLY_MOUNTED = &H80000000
End Enum

Public Type SCSI_PASS_THROUGH
   Length As Integer
   ScsiStatus As Byte
   PathId  As Byte
   TargetId  As Byte
   Lun As Byte
   CdbLength  As Byte
   SenseInfoLength  As Byte
   DataIn  As Byte
   DataTransferLength As Long
   TimeOutValue As Long
   DataBufferOffset As Long
   SenseInfoOffset As Long
   Cdb(15) As Byte
End Type

Public Type SCSI_PASS_THROUGH_WITH_BUFFERS
   spt As SCSI_PASS_THROUGH
   Filler As Long     ' // realign buffers to double word boundary
   SenseBuf(31) As Byte
   DataBuf(511) As Byte
End Type

Public Type WRITE_PERFORMANCE_DESCRIPTOR
   RotationControl      As Integer
   WriteSpeedSupported  As Integer
End Type

Public Type CAPABILITY_PAGE
   PageCode                 As Byte    'Byte 0     :Page code (0x2a)
   PageLength               As Byte    'Byte 1     :Structure length
   Capabilities(5)          As Byte    'Byte 2-7   :Individual capabilities
                                       '    Byte 2   - Read capabilities
                                       '    Byte 3   - Write capabilities
                                       '    Byte 4,5 - Play capabilities
                                       '    Byte 6   - Load/unload media  capabilities
                                       '    Byte 7   - Changer capabilities
   MaxReadSpeedOld(1)       As Byte    'Byte 8-9   :Obsolete for SCSI-3
   VolumeLevels(1)          As Byte    'Byte 10-10 :Obsolete for SCSI-3
   BufferSize(1)            As Byte    'Byte 12-13 :
   CurrentReadSpeadOld(1)   As Byte    'Byte 14-15 :Obsolete for SCSI-3
   Reserved1                As Byte    'Byte 16    :
   DigitalOutputFmt         As Byte    'Byte 17    :
   MaxWriteSpeedOld(1)      As Byte    'Byte 18-19 :Obsolete for SCSI-3
   CurrentWriteSpeadOld(1)  As Byte    'Byte 20-21 :Obsolete for SCSI-3
   CopyManagement(1)        As Byte    'Byte 22-23 :
   Reserved2(1)             As Byte    'Byte 24-25 :
   Reserved3                As Byte    'Byte 26    :
   RotationControlSelected  As Byte    'Byte 27    :
   CurrentWriteSpead(1)     As Byte    'Byte 28-29 :
   numWPD(1)                As Byte    'Byte 30-31 :
   WPD()                    As WRITE_PERFORMANCE_DESCRIPTOR
End Type

Public Type CDROM_DATA_TYPE
    lType As Long
End Type

Public Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" ( _
        ByVal lpFileName As String, ByVal dwDesiredAccess As Long, _
        ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Long, _
        ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, _
        ByVal hTemplateFile As Long) As Long
Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Public Declare Function DeviceIoControl Lib "kernel32" (ByVal hDevice As Long, _
        ByVal dwIoControlCode As Long, lpInBuffer As Any, ByVal nInBufferSize As Long, _
        ByRef lpOutBuffer As Any, ByVal nOutBufferSize As Long, _
        ByRef lpBytesReturned As Long, ByVal lpOverlapped As Long) As Long
Public Const GENERIC_READ = &H80000000
Public Const GENERIC_WRITE = &H40000000
Public Const FILE_SHARE_READ = &H1
Public Const FILE_SHARE_WRITE = &H2
Public Const OPEN_EXISTING = 3
Public Const INVALID_HANDLE_VALUE = -1

Public Const SCSIOP_INQUIRY = &H12
Public Const SCSIOP_MODE_SENSE = &H1A
Public Const SCSI_IOCTL_DATA_IN = 1
Public Const MODE_PAGE_CAPABILITIES = &H2A
Public Const SCSI_ATAPI_DISK_INFO = &H51
Public Const SCSI_ATAPI_CAPACITY = &H25
Public Const SCSI_ATAPI_FORMAT_CAPACITY = &H23
Public Const CDB6GENERIC_LENGTH = 6

Public Function SCSI_GET_ADDRESS(ByVal hDevice As Long, sa As SCSI_ADDRESS) As Long
   Dim ret As Long
   sa.Length = Len(sa)
   SCSI_GET_ADDRESS = DeviceIoControl(hDevice, IOCTL_SCSI_GET_ADDRESS, ByVal 0&, 0, sa, Len(sa), ret, 0)
End Function

'Executing ATAPI commands (see to SPC-3 reference for all coomands available)
'====================================================================================
'Executing MODE_SENSE command (read capabilities page) to view capabilities supported
Public Function SCSI_READ_CAPABILITIES(ByVal hDevice As Long, sa As SCSI_ADDRESS, sptwb As SCSI_PASS_THROUGH_WITH_BUFFERS) As Long
   Dim ret As Long
   
   ZeroMemory sptwb, LenB(sptwb)
   sptwb.spt.PathId = sa.PathId
   sptwb.spt.TargetId = sa.TargetId
   sptwb.spt.Lun = sa.Lun
   sptwb.spt.DataTransferLength = 192
   sptwb.spt.Length = LenB(sptwb.spt)
   sptwb.spt.CdbLength = CDB6GENERIC_LENGTH
   sptwb.spt.SenseInfoLength = 24
   sptwb.spt.DataIn = SCSI_IOCTL_DATA_IN
   sptwb.spt.TimeOutValue = 10
   sptwb.spt.SenseInfoOffset = Len(sptwb.spt) + 4
   sptwb.spt.DataBufferOffset = sptwb.spt.SenseInfoOffset + UBound(sptwb.SenseBuf)
   sptwb.spt.Cdb(0) = SCSIOP_MODE_SENSE
   sptwb.spt.Cdb(1) = &H8
   sptwb.spt.Cdb(2) = MODE_PAGE_CAPABILITIES
   sptwb.spt.Cdb(4) = 192
   SCSI_READ_CAPABILITIES = DeviceIoControl(hDevice, IOCTL_SCSI_PASS_THROUGH, sptwb, _
                            LenB(sptwb.spt), sptwb, LenB(sptwb), ret, False)
End Function
'====================================================================================
'Executing READ_DISK_INFORMATION command to get media information
Public Function SCSI_READ_DISKINFO(ByVal hDevice As Long, sa As SCSI_ADDRESS, sptwb As SCSI_PASS_THROUGH_WITH_BUFFERS) As Long
   Dim ret As Long, i As Long
   
   ZeroMemory sptwb, LenB(sptwb)
   sptwb.spt.PathId = sa.PathId
   sptwb.spt.TargetId = sa.TargetId
   sptwb.spt.Lun = sa.Lun
   sptwb.spt.DataTransferLength = 32
   sptwb.spt.Length = LenB(sptwb.spt)
   sptwb.spt.CdbLength = 10
   sptwb.spt.SenseInfoLength = 24
   sptwb.spt.DataIn = SCSI_IOCTL_DATA_IN
   sptwb.spt.TimeOutValue = 10
   sptwb.spt.SenseInfoOffset = LenB(sptwb.spt) + 4
   sptwb.spt.DataBufferOffset = sptwb.spt.SenseInfoOffset + UBound(sptwb.SenseBuf) + 1
   sptwb.spt.Cdb(0) = SCSI_ATAPI_DISK_INFO
   sptwb.spt.Cdb(8) = 32
   SCSI_READ_DISKINFO = DeviceIoControl(hDevice, IOCTL_SCSI_PASS_THROUGH, sptwb, _
                        LenB(sptwb.spt), sptwb, LenB(sptwb), ret, False)
End Function

'====================================================================================
'Executing READ_CAPACITY command to get media capacity
Public Function SCSI_READ_CAPACITY(ByVal hDevice As Long, sa As SCSI_ADDRESS, sptwb As SCSI_PASS_THROUGH_WITH_BUFFERS) As Long
   Dim ret As Long, i As Long
   
   ZeroMemory sptwb, LenB(sptwb)
   sptwb.spt.PathId = sa.PathId
   sptwb.spt.TargetId = sa.TargetId
   sptwb.spt.Lun = sa.Lun
   sptwb.spt.DataTransferLength = 8
   sptwb.spt.Length = LenB(sptwb.spt)
   sptwb.spt.CdbLength = 10
   sptwb.spt.SenseInfoLength = 24
   sptwb.spt.DataIn = SCSI_IOCTL_DATA_IN
   sptwb.spt.TimeOutValue = 10
   sptwb.spt.SenseInfoOffset = LenB(sptwb.spt) + 4
   sptwb.spt.DataBufferOffset = sptwb.spt.SenseInfoOffset + UBound(sptwb.SenseBuf) + 1
   sptwb.spt.Cdb(0) = SCSI_ATAPI_CAPACITY
   sptwb.spt.Cdb(8) = 8
   
   SCSI_READ_CAPACITY = DeviceIoControl(hDevice, IOCTL_SCSI_PASS_THROUGH, sptwb, _
                               LenB(sptwb.spt), sptwb, LenB(sptwb), ret, False)
End Function

'====================================================================================
'Executing READ_FORMAT_CAPACITY command to get media formatted capacity
Public Function SCSI_READ_FORMAT_CAPACITY(ByVal hDevice As Long, sa As SCSI_ADDRESS, sptwb As SCSI_PASS_THROUGH_WITH_BUFFERS) As Long
   Dim ret As Long, i As Long
   
   ZeroMemory sptwb, LenB(sptwb)
   sptwb.spt.PathId = sa.PathId
   sptwb.spt.TargetId = sa.TargetId
   sptwb.spt.Lun = sa.Lun
   sptwb.spt.DataTransferLength = 12
   sptwb.spt.Length = LenB(sptwb.spt)
   sptwb.spt.CdbLength = 10
   sptwb.spt.SenseInfoLength = 24
   sptwb.spt.DataIn = SCSI_IOCTL_DATA_IN
   sptwb.spt.TimeOutValue = 10
   sptwb.spt.SenseInfoOffset = LenB(sptwb.spt) + 4
   sptwb.spt.DataBufferOffset = sptwb.spt.SenseInfoOffset + UBound(sptwb.SenseBuf) + 1
   sptwb.spt.Cdb(0) = SCSI_ATAPI_FORMAT_CAPACITY
   sptwb.spt.Cdb(8) = 12
   
   SCSI_READ_FORMAT_CAPACITY = DeviceIoControl(hDevice, IOCTL_SCSI_PASS_THROUGH, sptwb, _
                               LenB(sptwb.spt), sptwb, LenB(sptwb), ret, False)
End Function
