Attribute VB_Name = "mDiSetup"
Option Explicit

' Device Property Value(s)...
Public Enum DEVICEPROPERTYINDEX
   SPDRP_DEVICEDESC = 0              '(0x00000000)  // DeviceDesc (R/W)
   SPDRP_HARDWAREID                  '(0x00000001)  // HardwareID (R/W)
   SPDRP_COMPATIBLEIDS               '(0x00000002)  // CompatibleIDs (R/W)
   SPDRP_UNUSED0                     '(0x00000003)  // unused
   SPDRP_SERVICE                     '(0x00000004)  // Service (R/W)
   SPDRP_UNUSED1                     '(0x00000005)  // unused
   SPDRP_UNUSED2                     '(0x00000006)  // unused
   SPDRP_CLASS                       '(0x00000007)  // Class (R--tied to ClassGUID)
   SPDRP_CLASSGUID                   '(0x00000008)  // ClassGUID (R/W)
   SPDRP_DRIVER                      '(0x00000009)  // Driver (R/W)
   SPDRP_CONFIGFLAGS                 '(0x0000000A)  // ConfigFlags (R/W)
   SPDRP_MFG                         '(0x0000000B)  // Mfg (R/W)
   SPDRP_FRIENDLYNAME                '(0x0000000C)  // FriendlyName (R/W)
   SPDRP_LOCATION_INFORMATION        '(0x0000000D)  // LocationInformation (R / W)
   SPDRP_PHYSICAL_DEVICE_OBJECT_NAME '(0x0000000E)  // PhysicalDeviceObjectName (R)
   SPDRP_CAPABILITIES                '(0x0000000F)  // Capabilities (R)
   SPDRP_UI_NUMBER                   '(0x00000010)  // UiNumber (R)
   SPDRP_UPPERFILTERS                '(0x00000011)  // UpperFilters (R/W)
   SPDRP_LOWERFILTERS                '(0x00000012)  // LowerFilters (R/W)
   SPDRP_BUSTYPEGUID                 '(0x00000013)  // BusTypeGUID (R)
   SPDRP_LEGACYBUSTYPE               '(0x00000014)  // LegacyBusType (R)
   SPDRP_BUSNUMBER                   '(0x00000015)  // BusNumber (R)
   SPDRP_ENUMERATOR_NAME             '(0x00000016)  // Enumerator Name (R)
   SPDRP_SECURITY                    '(0x00000017)  // Security (R/W, binary form)
   SPDRP_SECURITY_SDS                '(0x00000018)  // Security (W, SDS form)
   SPDRP_DEVTYPE                     '(0x00000019)  // Device Type (R/W)
   SPDRP_EXCLUSIVE                   '(0x0000001A)  // Device is Exclusive -access(R / W)
   SPDRP_CHARACTERISTICS             '(0x0000001B)  // Device Characteristics (R / W)
   SPDRP_ADDRESS                     '(0x0000001C)  // Device Address (R)
   SPDRP_UI_NUMBER_DESC_FORMAT       '(0x0000001D)  // UiNumberDescFormat (R/W)
   SPDRP_DEVICE_POWER_DATA           '(0x0000001E)  // Device Power Data (R)
   SPDRP_REMOVAL_POLICY              '(0x0000001F)  // Removal Policy (R)
   SPDRP_REMOVAL_POLICY_HW_DEFAULT   '(0x00000020)  // Hardware Removal Policy (R)
   SPDRP_REMOVAL_POLICY_OVERRIDE     '(0x00000021)  // Removal Policy Override (RW)
   SPDRP_INSTALL_STATE               '(0x00000022)  // Device Install State (R)
   SPDRP_LOCATION_PATHS              '(0x00000023)  // Device Location Paths (R)
   SPDRP_MAXIMUM_PROPERTY            '(0x00000024)  // Upper bound on ordinals
End Enum

Private Enum REGPROPERTYTYPES
   REG_SZ = 1
   REG_EXPAND_SZ = 2
   REG_BINARY = 3
   REG_DWORD = 4
   REG_DWORD_BIG_ENDIAN = 5
   REG_DWORD_LITTLE_ENDIAN = REG_DWORD
   REG_MULTI_SZ = 7
End Enum

Private Enum SetupErrors
   ERROR_INVALID_DATA = 13&
   ERROR_INSUFFICIENT_BUFFER = 122&
   ERROR_NO_MORE_ITEMS = 259&
End Enum

Private Enum DEVICEFLAGS
   DIGCF_PRESENT = &H2&
   DIGCF_ALLCLASSES = &H4&
   DIGCF_PROFILE = &H8&
   DIGCF_DEVICEINTERFACE = &H10&
End Enum

Private Type Guid
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(0 To 7) As Byte
End Type

Private Type SP_DEVINFO_DATA
   cbSize As Long
   ClassGuid As Guid
   DevInst As Long
   Reserved As Long
End Type

Private Declare Function CLSIDFromString Lib "ole32" (ByVal lpsz As Any, pclsid As Guid) As Long

Private Declare Function SetupDiGetClassDevs Lib "setupapi.dll" _
        Alias "SetupDiGetClassDevsA" (ByRef ClassGuid As Guid, _
        ByVal Enumerator As String, ByVal hwndParent As Long, _
        ByVal flags As DEVICEFLAGS) As Long

Private Declare Function SetupDiEnumDeviceInfo Lib "setupapi.dll" ( _
        ByVal DeviceInfoSet As Long, ByVal MemberIndex As Long, _
        ByRef DeviceInfoData As SP_DEVINFO_DATA) As Long

Private Declare Function SetupDiDestroyDeviceInfoList Lib "setupapi.dll" (ByVal DeviceInfoSet As Long) As Long

Private Declare Function SetupDiGetDeviceRegistryProperty Lib "setupapi.dll" _
        Alias "SetupDiGetDeviceRegistryPropertyA" ( _
        ByVal DeviceInfoSet As Long, ByRef DeviceInfoData As SP_DEVINFO_DATA, _
        ByVal Property As DEVICEPROPERTYINDEX, ByRef PropertyRegDataType As REGPROPERTYTYPES, _
        ByVal PropertyBuffer As String, ByVal PropertyBufferSize As Long, _
        ByRef RequiredSize As Long) As Long

Private Declare Function SetupDiEnumDeviceInterfaces Lib "setupapi.dll" ( _
        ByVal DeviceInfoSet As Long, _
        ByRef DeviceInfoData As Any, _
        ByRef InterfaceClassGuid As Guid, _
        ByVal MemberIndex As Long, _
        ByRef DeviceInterfaceData As SP_DEVINFO_DATA) As Long

Private Declare Function SetupDiGetDeviceInterfaceDetail Lib "setupapi.dll" _
        Alias "SetupDiGetDeviceInterfaceDetailA" ( _
        ByVal DeviceInfoSet As Long, _
        ByRef DeviceInterfaceData As Any, _
        ByRef DeviceInterfaceDetailData As Any, _
        ByVal DeviceInterfaceDetailDataSize As Long, _
        ByRef RequiredSize As Long, _
        ByRef DeviceInfoData As Any) As Long

Public Const DEVICE_CLASS_COMPACT_DISC As String = "{4d36e965-e325-11ce-bfc1-08002be10318}"
Public Const DEVICE_CLASS_DISKDRIVE    As String = "{4d36e967-e325-11ce-bfc1-08002be10318}"
Public Const DEVICE_CLASS_TAPEDRIVE    As String = "{6d807884-7d21-11cf-801c-08002be10318}"

Public Function GetDeviceSetting(ByVal sCLSID As String, _
   ByVal idx As Long, ByVal Property As DEVICEPROPERTYINDEX) As String
  
   Dim DID As SP_DEVINFO_DATA
   Dim gd As Guid
   Dim hDevInfo As Long
   
   Call CLSIDFromString(StrPtr(sCLSID), gd)
     
   hDevInfo = SetupDiGetClassDevs(gd, vbNullString, 0, DIGCF_PRESENT)
   If hDevInfo = -1 Then Exit Function
   DID.cbSize = Len(DID)
   DID.ClassGuid = gd
   If SetupDiEnumDeviceInfo(hDevInfo, idx, DID) <> 0 Then
      GetDeviceSetting = ReadSetupRegSetting(hDevInfo, DID, Property)
   End If
   Call SetupDiDestroyDeviceInfoList(hDevInfo)
End Function

Private Function ReadSetupRegSetting(ByVal hDevInfo As Long, DID As SP_DEVINFO_DATA, _
        ByVal RegSetting As DEVICEPROPERTYINDEX) As String
   Dim BuffStr As String
   Dim BuffLng As Long
   Dim BufferLen As Long
   Dim RegType As REGPROPERTYTYPES
   Dim Retval As Long
   
   Call SetupDiGetDeviceRegistryProperty(hDevInfo, DID, RegSetting, RegType, "", 0&, BufferLen)
   
   If Err.LastDllError = ERROR_INSUFFICIENT_BUFFER Then
      Select Case RegType
             Case REG_SZ, REG_MULTI_SZ, REG_EXPAND_SZ, REG_BINARY
                  BuffStr = Space$(BufferLen)
                  Retval = SetupDiGetDeviceRegistryProperty(hDevInfo, DID, RegSetting, _
                           RegType, BuffStr, Len(BuffStr), BufferLen)
                   
             Case REG_DWORD, REG_DWORD_BIG_ENDIAN, REG_DWORD_LITTLE_ENDIAN
                  Retval = SetupDiGetDeviceRegistryProperty(hDevInfo, DID, RegSetting, RegType, _
                           BuffLng, Len(BuffLng), BufferLen)
                  BuffStr = CStr(BuffLng)
                  BufferLen = BufferLen + 1
       End Select
       If Retval <> 0 Then ReadSetupRegSetting = Trim(Left$(BuffStr, BufferLen - 1))
   End If
End Function

Public Function GetCDFriendlyNames() As String()
   Dim sNames() As String
   Dim sGuid As String
   Dim DID As SP_DEVINFO_DATA
   Dim gd As Guid
   Dim hDevInfo As Long, i As Long
   
   sGuid = DEVICE_CLASS_COMPACT_DISC
   Call CLSIDFromString(StrPtr(sGuid), gd)
     
   hDevInfo = SetupDiGetClassDevs(gd, vbNullString, 0, DIGCF_PRESENT)
   If hDevInfo = -1 Then Exit Function
   DID.cbSize = Len(DID)
   DID.ClassGuid = gd
   Do
      If SetupDiEnumDeviceInfo(hDevInfo, i, DID) = 0 Then
         If Err.LastDllError = ERROR_NO_MORE_ITEMS Then Exit Do
      Else
        ReDim Preserve sNames(i)
        sNames(i) = ReadSetupRegSetting(hDevInfo, DID, SPDRP_FRIENDLYNAME)
      End If
      i = i + 1
   Loop
   Call SetupDiDestroyDeviceInfoList(hDevInfo)
   GetCDFriendlyNames = sNames
End Function
